package de.fraunhofer.fit.train.model;

import java.util.List;

import org.bson.types.ObjectId;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.stereotype.Repository;

import com.google.gson.annotations.Expose;
import com.google.gson.annotations.SerializedName;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;


@Api(value = "Train4FAIRObject aims to be the wrapper, a kind of bridge to support the relation between prefix and his many suffixes.",
tags = {"train4fairdoi"})
@Repository
@Document(collection = "train4fairdoi")
public class Train4FAIRObject {
	
	
	@ApiModelProperty(notes = "Unique and Internal identifier of the related objet. This field is randomly generated by the platform.", 
            example = "Auto Generated",  position = 0)
	@Id
	@SerializedName("_id")
	@Expose
	private ObjectId _id;
	
	@ApiModelProperty(notes = "This field aims to hold one Prefix object, as well as, all his properties. This field is autogenerate by the Platform always the user of the service requesta new PID.", 
            example = "Auto Generated",  position = 1)
	@SerializedName("prefix")
	@Expose
	private Prefix prefix;
	
	@ApiModelProperty(notes = "This field aims to hold a list of Suffiexs Objects. Those object holds all the features related to the suffix. This field is autogenerate by the Platform when the user already have an PID/Prefix and call the service to attach a new suffix to that PID. ", 
            example = "Auto Generated",  position = 2)
	@SerializedName("suffixes")
	@Expose
	private List<Suffix> suffixes;
	

	@ApiModelProperty(notes = "This field aims to hold the PID URI which is a composition of the platform host, prefix and sufix. This field is autogenerate by the Platform when the user already have an PID/Prefix and call the service to attach a new suffix to that PID. ", 
            example = "Auto Generated",  position = 3)
	@SerializedName("uri")
	@Expose
	private String uri;
	
	
	

	public String getUri() {
		return uri;
	}

	public void setUri(String uri) {
		this.uri = uri;
	}

	public Prefix getPrefix() {
		return prefix;
	}

	public void setPrefix(Prefix prefix) {
		this.prefix = prefix;
	}


	public List<Suffix> getSuffixes() {
		return suffixes;
	}

	public void setSuffixes(List<Suffix> suffixes) {
		this.suffixes = suffixes;
	}


	public ObjectId get_id() {
		return _id;
	}

	public void set_id(ObjectId _id) {
		this._id = _id;
	}
	
	
	
	

}
